<?
/* 
(C) 2004-2013 DatuX - info@datux.nl

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

$LEVEL=10;
require_once("../common.php");
require_once("network.php");


Title(_NetworkCheck());
Head();


function PrintCheckStart($desc)
{
	echo "<tr>";
	echo "<td>$desc";
	echo "<td>";
	Progress($desc);
}

function PrintCheckResult($check, $result)
{
	echo "<a target='_new' href='".GetHelpUri($check)."'>"; 
	echo "<img src='../img/$result.gif'>";
	echo "</a>";
	echo "</tr>";
}


echo "<h1>$TITLE</h1>";

echo "<table class='list'>";

//default gateway link up?
$cards=GetCards();
$dev=GetCurrentDefaultDev();
PrintCheckStart(_CheckingGatewayLinkStatus($cards[$dev][desc]));
if ($cards[$dev]['link']==1)
	PrintCheckResult("link","OK");
elseif ($cards[$dev]['link']==0)
	PrintCheckResult("link","WARNING");
else
	PrintCheckResult("link","OK");


//Default gateway responds to arp?
$gw=GetCurrentDefaultGw();
PrintCheckStart(_CheckingGateway($gw));
if (!Cmd("arping -f -c 3 -I '$dev' '$gw'"))
	PrintCheckResult("arp","OK");
else
	PrintCheckResult("arp","ERROR");


//check gateway ping routing
$testip="8.8.8.8"; //google dns
PrintCheckStart(_CheckingGatewayPing($testip));
if (!Cmd("fping $testip"))
	PrintCheckResult("ping","OK");
else
	PrintCheckResult("ping","ERROR");

//check gateway ping routing
$testip="1.1.1.1"; //cloudflare
PrintCheckStart(_CheckingGatewayPing($testip));
if (!Cmd("fping $testip"))
	PrintCheckResult("ping","OK");
else
	PrintCheckResult("ping","ERROR");

	
//check dns servers 
$dnss=getDNS();
foreach ($dnss as $dns)
{
	PrintCheckStart(_CheckingDNS($dns));
	if (!Cmd("dig www.google.com @$dns | grep ^www.google.com"))
		PrintCheckResult("dns","OK");
	else
		PrintCheckResult("dns","ERROR");
}

//check http via google
PrintCheckStart(_CheckingGatewayHttpUpdateserver("www.google.com"));
if (!Cmd("lynx -dump -connect_timeout 10 www.google.com"))
	PrintCheckResult("http","OK");
else
	PrintCheckResult("http","ERROR");


//check uitgaande mail connectie naar 25
//veel providers zetten dit dicht.

$testmail="smtp.google.com";
PrintCheckStart(_CheckingGatewayMail($testmail));
if (!Cmd("nc $testmail 25 -w 1 -q 1 -z"))
	PrintCheckResult("mail","OK");
else
	PrintCheckResult("mail","ERROR");


if (ModuleMatch("I"))
{
	PrintCheckStart(_CheckingIpsecPort("500"));
	
	$port500=SafeExec("grep ':.*not enough room' /var/log/secure |tail -1");
	$port4500=SafeExec("grep ':.*too small packet' /var/log/secure |tail -1");
	
	rpc("TestIpsec");
	
	$port500tested=SafeExec("grep ':.*not enough room' /var/log/secure |tail -1");
	$port4500tested=SafeExec("grep ':.*too small packet' /var/log/secure |tail -1");
	
	if ($port500[0]!=$port500tested[0])
		PrintCheckResult("ipsec","OK");
	else
		PrintCheckResult("ipsec","WARNING");
	
	
	PrintCheckStart(_CheckingIpsecPort("4500"));
	if ($port4500[0]!=$port4500tested[0])
		PrintCheckResult("ipsec","OK");
	else
		PrintCheckResult("ipsec","WARNING");
}


echo "</table>";


echo "<a href='check.php'>";
echo _TestAgain();
echo "</a>";


Foot();